###
# Handles the events that the server passes.
###
class Orator.Libraries.EventHandler

  ###
  # Constructor.
  ###
  constructor: (@context)->
    @events = []

  ###
  # Sets up a callback for the event given.  First argument is the event, the
  # second is the callback.
  ###
  on: (event, cb, times = Infinity)->
    @events.push([event, cb, times])

  ###
  # Runs the event with the context and the arguments.  This runs all of the
  # events that match, and returns an array of the results.
  ###
  trigger: (event, args...)->
    events = @_find_events(event)

    return false if events.length == 0

    for event in events
      event[1].apply(@context, args)

      if event[2]-- <= 0
        @events.splice(@events.indexOf(event), 1)

  ###
  # Finds the events that match the given event.
  ###
  _find_events: (event)->
    out = []

    for r in @events
      if r[0] == event
        out.push(r)

    out

